import sys
import random
import numpy as np
from utils_data import extract_bags
from numpy.random import randint

def convert_to_triplet_bags(bags, M, args):
    p_bags = extract_bags(bags,  1, with_label = True) # list type
    n_bags = extract_bags(bags, -1, with_label = True)
    np.random.shuffle(p_bags)
    np.random.shuffle(n_bags)    
    prior = args.prior 
    P = len(p_bags)
    N = len(n_bags)    
#    print(P, N)
    n1 = int(M * (1 - prior * (1 - prior)))
    n2 = M - n1
    n1a = int(M * prior * prior * prior)
    n1b = int(M * prior * prior * (1 - prior))
    n1c = int(M * prior * (1 - prior) * (1 - prior))
    n1d = int(n1 - n1a - 2 * (n1b + n1c))
    n2a = int(M * prior * prior * (1 - prior))
    n2b = int(n2 - n2a)

    num_TP = P - (n1a*3 + n1b*4+ n1c*2 + n2a*2 + n2b)
    num_TN = N - (n1d*3 + n1c*4+ n1b*2 + n2b*2 + n2a)
    num_T1 = int(num_TP/prior)
    num_T2 = int(num_TN/(1-prior))
    if num_T1 <=num_T2:
        TP = num_TP
        TN = num_T1 - TP
    else:
        TN = num_TN
        TP = num_T2 - TN
    assert n1a*3 + n1b*4+ n1c*2 + n2a*2 + n2b + TP<= P, "Not enough positive bags!"
    assert n1d*3 + n1c*4+ n1b*2 + n2b*2 + n2a + TN<= N, "Not enough negative bags!"
    Xt1_1 = p_bags[:n1a][:int(n1a)] + p_bags[n1a:(n1a+n1b)][:int(n1b)] + p_bags[(n1a+n1b):(n1a+n1b+n1c)][:int(n1c)] + n_bags[:n1b][:int(n1b)] + n_bags[n1b:(n1b+n1c)][:int(n1c)] + n_bags[(n1b+n1c):(n1b+n1c+n1d)][:int(n1d)]
    Xt1_2 = p_bags[(n1a+n1b+n1c):(2*n1a+n1b+n1c)][:int(n1a)] + p_bags[(2*n1a+n1b+n1c):(2*n1a+2*n1b+n1c)][:int(n1b)] + n_bags[(n1b+n1c+n1d):(n1b+2*n1c+n1d)][:int(n1c)] + p_bags[(2*n1a+2*n1b+n1c):(2*n1a+3*n1b+n1c)][:int(n1b)] + n_bags[(n1b+2*n1c+n1d):(n1b+3*n1c+n1d)][:int(n1c)] + n_bags[(n1b+3*n1c+n1d):(n1b+3*n1c+2*n1d)][:int(n1d)]
    Xt1_3 = p_bags[(2*n1a+3*n1b+n1c):(3*n1a+3*n1b+n1c)][:int(n1a)] + n_bags[(n1b+3*n1c+2*n1d):(2*n1b+3*n1c+2*n1d)][:int(n1b)] + n_bags[(2*n1b+3*n1c+2*n1d):(2*n1b+4*n1c+2*n1d)][:int(n1c)] + p_bags[(3*n1a+3*n1b+n1c):(3*n1a+4*n1b+n1c)][:int(n1b)] + p_bags[(3*n1a+4*n1b+n1c):(3*n1a+4*n1b+2*n1c)][:int(n1c)] + n_bags[(2*n1b+4*n1c+2*n1d):(2*n1b+4*n1c+3*n1d)][:int(n1d)]
    
    Xt2_1 = p_bags[(3*n1a+4*n1b+2*n1c):(3*n1a+4*n1b+2*n1c+n2a)][:int(n2a)] + n_bags[(2*n1b+4*n1c+3*n1d):(2*n1b+4*n1c+3*n1d+n2b)][:int(n2b)]
    Xt2_2 = n_bags[(2*n1b+4*n1c+3*n1d+n2b):(2*n1b+4*n1c+3*n1d+n2b+n2a)][:int(n2a)] + p_bags[(3*n1a+4*n1b+2*n1c+n2a):(3*n1a+4*n1b+2*n1c+n2a+n2b)][:int(n2b)]
    Xt2_3 = p_bags[(3*n1a+4*n1b+2*n1c+n2a+n2b):(3*n1a+4*n1b+2*n1c+2*n2a+n2b)][:int(n2)] + n_bags[(2*n1b+4*n1c+3*n1d+n2b+n2a):(2*n1b+4*n1c+3*n1d+2*n2b+n2a)][:int(n2b)]
    
    Xa_bags = Xt1_1 + Xt1_3 + Xt2_1 + Xt2_3
    Xb_bags = Xt1_2
    Xc_bags = Xt2_2
    test_bags = p_bags[(3*n1a+4*n1b+2*n1c+2*n2a+n2b):(3*n1a+4*n1b+2*n1c+2*n2a+n2b+TP)] + n_bags[(2*n1b+4*n1c+3*n1d+2*n2b+n2a):(2*n1b+4*n1c+3*n1d+2*n2b+n2a+TN)]


    return Xa_bags, Xb_bags, Xc_bags, test_bags, n1, n2
